#! /usr/bin/perl -w 
use strict;
use warnings;

#In this simplified example the map coordinates are:
#X: distance between the "H1" atom of residue 1 and the "O" atom of residue 1
#Y: distance between the "H1" atom of residue 1 and the "O" atom of residue 2

#In order to actually use the script first edit the restraints definitions bellow to the ones you are using (note the values in the example restraints are just placeholders).
#Then execute the script using the path file and output files name as arguments

my $line;
my @X;
my @Y;
my @path_text;
my $array_counter;
my $prev_array_counter;

if (@ARGV == 2)
{
	if (-e $ARGV[0])
	{
		open (FH1,$ARGV[0]);
		@path_text = <FH1>;
		close FH1;
		foreach $line(@path_text)
		{
			if ($line =~ /(-?\d+\.\d+)\s(-?\d+\.\d+)/)
			{
				print "\n$1 $2\n";
				push (@X,$1);
				push (@Y,$2);
			}

		}
		$array_counter = 1;
		$prev_array_counter = $array_counter - 1;
		foreach (@X)
		{
		        if ($array_counter != @X)
			{
				open (FH1,">$ARGV[1]_rst$array_counter.dat");
				print FH1 '
# X coordinate of the map
 &rst iat= 1, 1,   
      atnam(1)=\'H1\', atnam(2)=\'O\',
      ifvari=1, nstep1= 0, nstep2= 1000,
      r1= 0, r2= ' . $X[$prev_array_counter] . ', r3= ' . $X[$prev_array_counter] . ', r4= 5,
      r1a= 0, r2a= ' . $X[$array_counter] . ', r3a= ' . $X[$array_counter] . ', r4a= 5,
      rk2= 100, rk3= 100, rk2a= 100, rk3a= 100,
      iresid=1, &end

# Y coordiate of the map
 &rst iat= 1, 2,   
      atnam(1)=\'H1\', atnam(2)=\'O\',
      ifvari=1, nstep1= 0, nstep2= 1000,
      r1= 0, r2= ' . $Y[$prev_array_counter] . ', r3= ' . $Y[$prev_array_counter] . ', r4= 5,
      r1a= 0, r2a= ' . $Y[$array_counter] . ', r3a= ' . $Y[$array_counter] . ', r4a= 5,
      rk2= 100, rk3= 100, rk2a= 100, rk3a= 100,
      iresid=1, &end

# EXAMPLE OF A SET OF FIXED RESTRAINTS
 &rst iat= 1, 1,
      atnam(1)=\'H2\', atnam(2)=\'O\',
      ifvari=0,
      r1= 0, r2= 0, r3= 1.2, r4= 5,
      rk2= 100, rk3= 100
      iresid=1, &end

 &rst iat= 2, 2,
      atnam(1)=\'H1\', atnam(2)=\'O\',
      ifvari=0,
      r1= 0, r2= 0, r3= 1.2, r4= 5,
      rk2= 100, rk3= 100
      iresid=1, &end

 &rst iat= 2, 2,
      atnam(1)=\'H2\', atnam(2)=\'O\',
      ifvari=0,
      r1= 0, r2= 0, r3= 1.2, r4= 5,
      rk2= 100, rk3= 100
      iresid=1, &end
		';
				close FH1;
				$array_counter++;
				$prev_array_counter++;
			}
		}
	}
	else
	{
		print "\nFile \"$ARGV[0]\" could not be opened.\nUse path file (FIRST) and output name (SECOND) as arguments.\n\n";
	}
}
else
{
	print "\nWrong number of arguments. Use path file (FIRST) and output name (SECOND) as arguments.\n\n"
}
